// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
pub use crate::operation::list_async_invokes::_list_async_invokes_output::ListAsyncInvokesOutputBuilder;

pub use crate::operation::list_async_invokes::_list_async_invokes_input::ListAsyncInvokesInputBuilder;

impl crate::operation::list_async_invokes::builders::ListAsyncInvokesInputBuilder {
    /// Sends a request with this input using the given client.
    pub async fn send_with(
        self,
        client: &crate::Client,
    ) -> ::std::result::Result<
        crate::operation::list_async_invokes::ListAsyncInvokesOutput,
        ::aws_smithy_runtime_api::client::result::SdkError<
            crate::operation::list_async_invokes::ListAsyncInvokesError,
            ::aws_smithy_runtime_api::client::orchestrator::HttpResponse,
        >,
    > {
        let mut fluent_builder = client.list_async_invokes();
        fluent_builder.inner = self;
        fluent_builder.send().await
    }
}
/// Fluent builder constructing a request to `ListAsyncInvokes`.
///
/// <p>Lists asynchronous invocations.</p>
#[derive(::std::clone::Clone, ::std::fmt::Debug)]
pub struct ListAsyncInvokesFluentBuilder {
    handle: ::std::sync::Arc<crate::client::Handle>,
    inner: crate::operation::list_async_invokes::builders::ListAsyncInvokesInputBuilder,
    config_override: ::std::option::Option<crate::config::Builder>,
}
impl
    crate::client::customize::internal::CustomizableSend<
        crate::operation::list_async_invokes::ListAsyncInvokesOutput,
        crate::operation::list_async_invokes::ListAsyncInvokesError,
    > for ListAsyncInvokesFluentBuilder
{
    fn send(
        self,
        config_override: crate::config::Builder,
    ) -> crate::client::customize::internal::BoxFuture<
        crate::client::customize::internal::SendResult<
            crate::operation::list_async_invokes::ListAsyncInvokesOutput,
            crate::operation::list_async_invokes::ListAsyncInvokesError,
        >,
    > {
        ::std::boxed::Box::pin(async move { self.config_override(config_override).send().await })
    }
}
impl ListAsyncInvokesFluentBuilder {
    /// Creates a new `ListAsyncInvokesFluentBuilder`.
    pub(crate) fn new(handle: ::std::sync::Arc<crate::client::Handle>) -> Self {
        Self {
            handle,
            inner: ::std::default::Default::default(),
            config_override: ::std::option::Option::None,
        }
    }
    /// Access the ListAsyncInvokes as a reference.
    pub fn as_input(&self) -> &crate::operation::list_async_invokes::builders::ListAsyncInvokesInputBuilder {
        &self.inner
    }
    /// Sends the request and returns the response.
    ///
    /// If an error occurs, an `SdkError` will be returned with additional details that
    /// can be matched against.
    ///
    /// By default, any retryable failures will be retried twice. Retry behavior
    /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
    /// set when configuring the client.
    pub async fn send(
        self,
    ) -> ::std::result::Result<
        crate::operation::list_async_invokes::ListAsyncInvokesOutput,
        ::aws_smithy_runtime_api::client::result::SdkError<
            crate::operation::list_async_invokes::ListAsyncInvokesError,
            ::aws_smithy_runtime_api::client::orchestrator::HttpResponse,
        >,
    > {
        let input = self
            .inner
            .build()
            .map_err(::aws_smithy_runtime_api::client::result::SdkError::construction_failure)?;
        let runtime_plugins = crate::operation::list_async_invokes::ListAsyncInvokes::operation_runtime_plugins(
            self.handle.runtime_plugins.clone(),
            &self.handle.conf,
            self.config_override,
        );
        crate::operation::list_async_invokes::ListAsyncInvokes::orchestrate(&runtime_plugins, input).await
    }

    /// Consumes this builder, creating a customizable operation that can be modified before being sent.
    pub fn customize(
        self,
    ) -> crate::client::customize::CustomizableOperation<
        crate::operation::list_async_invokes::ListAsyncInvokesOutput,
        crate::operation::list_async_invokes::ListAsyncInvokesError,
        Self,
    > {
        crate::client::customize::CustomizableOperation::new(self)
    }
    pub(crate) fn config_override(mut self, config_override: impl ::std::convert::Into<crate::config::Builder>) -> Self {
        self.set_config_override(::std::option::Option::Some(config_override.into()));
        self
    }

    pub(crate) fn set_config_override(&mut self, config_override: ::std::option::Option<crate::config::Builder>) -> &mut Self {
        self.config_override = config_override;
        self
    }
    /// Create a paginator for this request
    ///
    /// Paginators are used by calling [`send().await`](crate::operation::list_async_invokes::paginator::ListAsyncInvokesPaginator::send) which returns a [`PaginationStream`](aws_smithy_async::future::pagination_stream::PaginationStream).
    pub fn into_paginator(self) -> crate::operation::list_async_invokes::paginator::ListAsyncInvokesPaginator {
        crate::operation::list_async_invokes::paginator::ListAsyncInvokesPaginator::new(self.handle, self.inner)
    }
    /// <p>Include invocations submitted after this time.</p>
    pub fn submit_time_after(mut self, input: ::aws_smithy_types::DateTime) -> Self {
        self.inner = self.inner.submit_time_after(input);
        self
    }
    /// <p>Include invocations submitted after this time.</p>
    pub fn set_submit_time_after(mut self, input: ::std::option::Option<::aws_smithy_types::DateTime>) -> Self {
        self.inner = self.inner.set_submit_time_after(input);
        self
    }
    /// <p>Include invocations submitted after this time.</p>
    pub fn get_submit_time_after(&self) -> &::std::option::Option<::aws_smithy_types::DateTime> {
        self.inner.get_submit_time_after()
    }
    /// <p>Include invocations submitted before this time.</p>
    pub fn submit_time_before(mut self, input: ::aws_smithy_types::DateTime) -> Self {
        self.inner = self.inner.submit_time_before(input);
        self
    }
    /// <p>Include invocations submitted before this time.</p>
    pub fn set_submit_time_before(mut self, input: ::std::option::Option<::aws_smithy_types::DateTime>) -> Self {
        self.inner = self.inner.set_submit_time_before(input);
        self
    }
    /// <p>Include invocations submitted before this time.</p>
    pub fn get_submit_time_before(&self) -> &::std::option::Option<::aws_smithy_types::DateTime> {
        self.inner.get_submit_time_before()
    }
    /// <p>Filter invocations by status.</p>
    pub fn status_equals(mut self, input: crate::types::AsyncInvokeStatus) -> Self {
        self.inner = self.inner.status_equals(input);
        self
    }
    /// <p>Filter invocations by status.</p>
    pub fn set_status_equals(mut self, input: ::std::option::Option<crate::types::AsyncInvokeStatus>) -> Self {
        self.inner = self.inner.set_status_equals(input);
        self
    }
    /// <p>Filter invocations by status.</p>
    pub fn get_status_equals(&self) -> &::std::option::Option<crate::types::AsyncInvokeStatus> {
        self.inner.get_status_equals()
    }
    /// <p>The maximum number of invocations to return in one page of results.</p>
    pub fn max_results(mut self, input: i32) -> Self {
        self.inner = self.inner.max_results(input);
        self
    }
    /// <p>The maximum number of invocations to return in one page of results.</p>
    pub fn set_max_results(mut self, input: ::std::option::Option<i32>) -> Self {
        self.inner = self.inner.set_max_results(input);
        self
    }
    /// <p>The maximum number of invocations to return in one page of results.</p>
    pub fn get_max_results(&self) -> &::std::option::Option<i32> {
        self.inner.get_max_results()
    }
    /// <p>Specify the pagination token from a previous request to retrieve the next page of results.</p>
    pub fn next_token(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        self.inner = self.inner.next_token(input.into());
        self
    }
    /// <p>Specify the pagination token from a previous request to retrieve the next page of results.</p>
    pub fn set_next_token(mut self, input: ::std::option::Option<::std::string::String>) -> Self {
        self.inner = self.inner.set_next_token(input);
        self
    }
    /// <p>Specify the pagination token from a previous request to retrieve the next page of results.</p>
    pub fn get_next_token(&self) -> &::std::option::Option<::std::string::String> {
        self.inner.get_next_token()
    }
    /// <p>How to sort the response.</p>
    pub fn sort_by(mut self, input: crate::types::SortAsyncInvocationBy) -> Self {
        self.inner = self.inner.sort_by(input);
        self
    }
    /// <p>How to sort the response.</p>
    pub fn set_sort_by(mut self, input: ::std::option::Option<crate::types::SortAsyncInvocationBy>) -> Self {
        self.inner = self.inner.set_sort_by(input);
        self
    }
    /// <p>How to sort the response.</p>
    pub fn get_sort_by(&self) -> &::std::option::Option<crate::types::SortAsyncInvocationBy> {
        self.inner.get_sort_by()
    }
    /// <p>The sorting order for the response.</p>
    pub fn sort_order(mut self, input: crate::types::SortOrder) -> Self {
        self.inner = self.inner.sort_order(input);
        self
    }
    /// <p>The sorting order for the response.</p>
    pub fn set_sort_order(mut self, input: ::std::option::Option<crate::types::SortOrder>) -> Self {
        self.inner = self.inner.set_sort_order(input);
        self
    }
    /// <p>The sorting order for the response.</p>
    pub fn get_sort_order(&self) -> &::std::option::Option<crate::types::SortOrder> {
        self.inner.get_sort_order()
    }
}
